﻿using System;
using System.Collections.Generic;
using Microsoft.AspNetCore.Mvc;
using MonitoringAnalysis.Business.Abstract;
using MonitoringAnalysis.Business.Exceptions;
using MonitoringAnalysis.Business.Models;
using MonitoringAnalysis.Domain.Entities;

namespace MonitoringAnalysis.api.Controllers
{
    /// <summary>
    /// Reports generated by Constancy and Average
    /// </summary>
    [Route("api/[controller]")]
    public class InformedEventController : Controller
    {
        public readonly IInformedEventService informedEventService;

        /// <summary>
        /// Reports generated by Constancy and Average
        /// </summary>
        /// <param name="informedEventService"></param>
        public InformedEventController(IInformedEventService informedEventService)
        {
            this.informedEventService = informedEventService;
        }

        /// <summary>
        /// All Reports 
        /// </summary>
        /// <returns>IEnumerable:InformedEvent</returns>
        [HttpGet]
        public IActionResult Get()
        {
            IEnumerable<InformedEvent> informedEvents = this.informedEventService.GetAll();
            return Ok(new { informedEvents });
        }

        /// <summary>
        /// Report filtered by sensor ID
        /// </summary>
        /// <param name="IdSensor"> sensor ID Guid Format</param>
        /// <returns>IEnumerable:InformedEvent</returns>
        [HttpPost]
        public IActionResult Post([FromBody]Guid IdSensor)
        {
            if (IdSensor == null && IdSensor == Guid.Empty)
                ModelState.AddModelError("Info", "Model Event value is " + GeneralErrors.NoNullValue.ToString());

            if (!ModelState.IsValid)
                return BadRequest(ModelState);

            IEnumerable<InformedEvent> informedEvents = this.informedEventService.Get(IdSensor);
            return Ok(new { informedEvents });
        }

    }
}
